'use strict';

/**
 * Scriptable iOS Type Definitions
 * 
 * @file Auto-generated abstract class definitions for Scriptable iOS
 * @version 1.0.1
 * @module scriptable-abstract
 * @generated 2024-12-17T17:04:07.426Z
 * @license MIT
 */
class ScriptableObject {
  __props = {};
  static __className;
  __get(propName) {
    return this.__props[propName];
  }
  __set(propName, value) {
    this.__props[propName] = value;
  }
}
class AbsAlert extends ScriptableObject {
  static __className = "Alert";
  /**
   * _Title displayed in the alert. Usually a short string._
   */
  get title() {
    return this.__get("title");
  }
  set title(value) {
    this.__set("title", value);
  }
  /**
   * _Detailed message displayed in the alert._
   */
  get message() {
    return this.__get("message");
  }
  set message(value) {
    this.__set("message", value);
  }
  /**
   * @param title string
   */
  addAction(_title) {
    throw new Error("Not implemented");
  }
  /**
   * @param title string
   */
  addDestructiveAction(_title) {
    throw new Error("Not implemented");
  }
  /**
   * @param title string
   */
  addCancelAction(_title) {
    throw new Error("Not implemented");
  }
  /**
   * @param placeholder string
   * @param text string
   * @returns {TextField}
   */
  addTextField(_placeholder, _text) {
    throw new Error("Not implemented");
  }
  /**
   * @param placeholder string
   * @param text string
   * @returns {TextField}
   */
  addSecureTextField(_placeholder, _text) {
    throw new Error("Not implemented");
  }
  /**
   * @param index number
   * @returns {string}
   */
  textFieldValue(_index) {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<number>}
   */
  present() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<number>}
   */
  presentAlert() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<number>}
   */
  presentSheet() {
    throw new Error("Not implemented");
  }
}
class AbsCalendar extends ScriptableObject {
  static __className = "Calendar";
  /**
   * _Calendar identifier._
   */
  get identifier() {
    return this.__get("identifier");
  }
  set identifier(value) {
    this.__set("identifier", value);
  }
  /**
   * _Title of calendar._
   */
  get title() {
    return this.__get("title");
  }
  set title(value) {
    this.__set("title", value);
  }
  /**
   * _Whether the calendar is a subscribed calendar._
   */
  get isSubscribed() {
    return this.__get("isSubscribed");
  }
  set isSubscribed(value) {
    this.__set("isSubscribed", value);
  }
  /**
   * _Indicates whether items can be added, edited, and deleted in the calendar._
   */
  get allowsContentModifications() {
    return this.__get("allowsContentModifications");
  }
  set allowsContentModifications(value) {
    this.__set("allowsContentModifications", value);
  }
  /**
   * _Color of calendar._
   */
  get color() {
    return this.__get("color");
  }
  set color(value) {
    this.__set("color", value);
  }
  /**
   * @param availability "busy" | "free" | "tentative" | "unavailable"
   * @returns {boolean}
   */
  supportsAvailability(_availability) {
    throw new Error("Not implemented");
  }
  /**
   */
  save() {
    throw new Error("Not implemented");
  }
  /**
   */
  remove() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<Calendar[]>}
   */
  static forReminders() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<Calendar[]>}
   */
  static forEvents() {
    throw new Error("Not implemented");
  }
  /**
   * @param title string
   * @returns {Promise<Calendar>}
   */
  static forRemindersByTitle(_title) {
    throw new Error("Not implemented");
  }
  /**
   * @param title string
   * @returns {Promise<Calendar>}
   */
  static forEventsByTitle(_title) {
    throw new Error("Not implemented");
  }
  /**
   * @param title string
   * @returns {Promise<Calendar>}
   */
  static createForReminders(_title) {
    throw new Error("Not implemented");
  }
  /**
   * @param title string
   * @returns {Promise<Calendar>}
   */
  static findOrCreateForReminders(_title) {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<Calendar>}
   */
  static defaultForReminders() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<Calendar>}
   */
  static defaultForEvents() {
    throw new Error("Not implemented");
  }
  /**
   * @param allowMultiple boolean
   * @returns {Promise<Calendar[]>}
   */
  static presentPicker(_allowMultiple) {
    throw new Error("Not implemented");
  }
}
class AbsCalendarEvent extends ScriptableObject {
  static __className = "CalendarEvent";
  /**
   * _Identifier of event._
   */
  get identifier() {
    return this.__get("identifier");
  }
  set identifier(value) {
    this.__set("identifier", value);
  }
  /**
   * _Title of event._
   */
  get title() {
    return this.__get("title");
  }
  set title(value) {
    this.__set("title", value);
  }
  /**
   * _Location of event._
   */
  get location() {
    return this.__get("location");
  }
  set location(value) {
    this.__set("location", value);
  }
  /**
   * _Notes associated with event._
   */
  get notes() {
    return this.__get("notes");
  }
  set notes(value) {
    this.__set("notes", value);
  }
  /**
   * _Start date of event._
   */
  get startDate() {
    return this.__get("startDate");
  }
  set startDate(value) {
    this.__set("startDate", value);
  }
  /**
   * _End date of event._
   */
  get endDate() {
    return this.__get("endDate");
  }
  set endDate(value) {
    this.__set("endDate", value);
  }
  /**
   * _Whether the event is an all-day event._
   */
  get isAllDay() {
    return this.__get("isAllDay");
  }
  set isAllDay(value) {
    this.__set("isAllDay", value);
  }
  /**
   * _Attendees associated with the event._
   *
   * An array of objects on the following form:
   *
   * {
   * "isCurrentUser": false,
   * "name": "John Appleseed",
   * "status": "accepted",
   * "type": "person",
   * "role": "required"
   * }
   *
   * Note that the property is read-only since iOS does not expose API to modify the attendees of an event.
   */
  get attendees() {
    return this.__get("attendees");
  }
  set attendees(value) {
    this.__set("attendees", value);
  }
  /**
   * _Availability during the event._
   *
   * Indicates how the event should be treated for scheduling purposes. The following values are supported:
   *
   * *   busy
   * *   free
   * *   tentative
   * *   unavailable
   *
   * Be aware that not all calendars support all of these availabilities and some calendars may not support availability at all. Use `Calendar.supportsAvailability()` to check if a
   * calendar supports a specific availability.
   *
   * @type {"busy" | "free" | "tentative" | "unavailable"}
   */
  get availability() {
    return this.__get("availability");
  }
  set availability(value) {
    this.__set("availability", value);
  }
  /**
   * _Time zone of event._
   *
   * Geopolitical region identifier that identifies the time zone, e.g. "Europe/Copenhagen", "America/New\_York" and "Asia/Tokyo".
   */
  get timeZone() {
    return this.__get("timeZone");
  }
  set timeZone(value) {
    this.__set("timeZone", value);
  }
  /**
   * _Calendar the event is stored in._
   */
  get calendar() {
    return this.__get("calendar");
  }
  set calendar(value) {
    this.__set("calendar", value);
  }
  /**
   * @param recurrenceRule RecurrenceRule
   */
  addRecurrenceRule(_recurrenceRule) {
    throw new Error("Not implemented");
  }
  /**
   */
  removeAllRecurrenceRules() {
    throw new Error("Not implemented");
  }
  /**
   */
  save() {
    throw new Error("Not implemented");
  }
  /**
   */
  remove() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<CalendarEvent>}
   */
  presentEdit() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<CalendarEvent>}
   */
  static presentCreate() {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<CalendarEvent[]>}
   */
  static today(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<CalendarEvent[]>}
   */
  static tomorrow(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<CalendarEvent[]>}
   */
  static yesterday(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<CalendarEvent[]>}
   */
  static thisWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<CalendarEvent[]>}
   */
  static nextWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<CalendarEvent[]>}
   */
  static lastWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param startDate Date
   * @param endDate Date
   * @param calendars readonly Calendar[]
   * @returns {Promise<CalendarEvent[]>}
   */
  static between(_startDate, _endDate, _calendars) {
    throw new Error("Not implemented");
  }
}
class AbsCallbackURL extends ScriptableObject {
  static __className = "CallbackURL";
  /**
   * @param name string
   * @param value string
   */
  addParameter(_name, _value) {
    throw new Error("Not implemented");
  }
  open() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {string}
   */
  getURL() {
    throw new Error("Not implemented");
  }
}
class AbsColor extends ScriptableObject {
  static __className = "Color";
  /**
   * _HEX representation._
   */
  get hex() {
    return this.__get("hex");
  }
  set hex(value) {
    this.__set("hex", value);
  }
  /**
   * _Amount of red in the color._
   */
  get red() {
    return this.__get("red");
  }
  set red(value) {
    this.__set("red", value);
  }
  /**
   * _Amount of green in the color._
   */
  get green() {
    return this.__get("green");
  }
  set green(value) {
    this.__set("green", value);
  }
  /**
   * _Amount of blue in the color._
   */
  get blue() {
    return this.__get("blue");
  }
  set blue(value) {
    this.__set("blue", value);
  }
  /**
   * _Alpha of the color._
   */
  get alpha() {
    return this.__get("alpha");
  }
  set alpha(value) {
    this.__set("alpha", value);
  }
  /**
   * @returns {Color}
   */
  static black() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static darkGray() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static lightGray() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static white() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static gray() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static red() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static green() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static blue() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static cyan() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static yellow() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static magenta() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static orange() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static purple() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static brown() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Color}
   */
  static clear() {
    throw new Error("Not implemented");
  }
  /**
   * @param lightColor Color
   * @param darkColor Color
   * @returns {Color}
   */
  static dynamic(_lightColor, _darkColor) {
    throw new Error("Not implemented");
  }
}
class AbsContact extends ScriptableObject {
  static __className = "Contact";
  /**
   * _Uniquely identifies the contact on the device._
   */
  get identifier() {
    return this.__get("identifier");
  }
  set identifier(value) {
    this.__set("identifier", value);
  }
  /**
   * _Name prefix._
   */
  get namePrefix() {
    return this.__get("namePrefix");
  }
  set namePrefix(value) {
    this.__set("namePrefix", value);
  }
  /**
   * _Given name._
   */
  get givenName() {
    return this.__get("givenName");
  }
  set givenName(value) {
    this.__set("givenName", value);
  }
  /**
   * _Middle name._
   */
  get middleName() {
    return this.__get("middleName");
  }
  set middleName(value) {
    this.__set("middleName", value);
  }
  /**
   * _Family name._
   */
  get familyName() {
    return this.__get("familyName");
  }
  set familyName(value) {
    this.__set("familyName", value);
  }
  /**
   * _Nickname._
   */
  get nickname() {
    return this.__get("nickname");
  }
  set nickname(value) {
    this.__set("nickname", value);
  }
  /**
   * _Birthday._
   */
  get birthday() {
    return this.__get("birthday");
  }
  set birthday(value) {
    this.__set("birthday", value);
  }
  /**
   * _Profile picture._
   */
  get image() {
    return this.__get("image");
  }
  set image(value) {
    this.__set("image", value);
  }
  /**
   * _Email addresses._
   *
   * An array of objects on the following form:
   *
   * {
   * "identifier": "UUID-ABC-123",
   * "label": "Home",
   * "localizedLabel": "Home",
   * "value": "my@example.com"
   * }
   *
   * The identifier uniquely identifies the email address on this device. The label is a description of the email address and the value holds the email address itself.
   *
   * When updating this property, you must set the entire array of email addresses that you would like to store on the contact. Each value in the array must have the "value" key. The
   * other keys are optional.
   */
  get emailAddresses() {
    return this.__get("emailAddresses");
  }
  set emailAddresses(value) {
    this.__set("emailAddresses", value);
  }
  /**
   * _Phone numbers._
   *
   * An array of objects on the following form:
   *
   * {
   * "identifier": "UUID-ABC-123",
   * "label": "Home",
   * "localizedLabel": "Home",
   * "value": "(111)234-5678"
   * }
   *
   * The identifier uniquely identifies the phone number on this device. The label is a description of the phone number and the value holds the phone number itself.
   *
   * When updating this property, you must set the entire array of phone numbers that you would like to store on the contact. Each value in the array must have the "value" key. The
   * other keys are optional.
   */
  get phoneNumbers() {
    return this.__get("phoneNumbers");
  }
  set phoneNumbers(value) {
    this.__set("phoneNumbers", value);
  }
  /**
   * _Postal addresses._
   *
   * An array of objects on the following form:
   *
   * {
   * "identifier": "UUID-ABC-123",
   * "label": "Home",
   * "localizedLabel": "Home",
   * "street": "240  Terry Lane",
   * "city": "New York",
   * "state": "New York",
   * "postalCode": "10001",
   * "country": "United States of America"
   * }
   *
   * The identifier uniquely identifies the postal address on this device. The label is a description of the postal address.
   *
   * When updating this property, you must set the entire array of postal addresses that you would like to store on the contact. The "identifier" key is optional.
   */
  get postalAddresses() {
    return this.__get("postalAddresses");
  }
  set postalAddresses(value) {
    this.__set("postalAddresses", value);
  }
  /**
   * _Social profiles._
   *
   * An array of objects on the following form:
   *
   * {
   * "identifier": "UUID-ABC-123",
   * "label": "Twitter",
   * "localizedLabel": "Twitter",
   * "service": "Twitter",
   * "url": "https://twitter.com/scriptableapp",
   * "userIdentifier": null,
   * "username": "scriptableapp"
   * }
   *
   * The identifier uniquely identifies the social profile on this device. The label is a description of the social profile, the service is the social profile's service name, the URL
   * contains a link to the social profile, the userIdentifier is the identifier of the social profile and the username is the name for the social profile.
   *
   * When updating this property, you must set the entire array of social profiles that you would like to store on the contact. The "identifier" key is optional.
   */
  get socialProfiles() {
    return this.__get("socialProfiles");
  }
  set socialProfiles(value) {
    this.__set("socialProfiles", value);
  }
  /**
   * _Note for the contact._
   *
   * For security reasons, a contact's notes cannot be accessed in Siri, the Shortcuts app and in a notification.
   */
  get note() {
    return this.__get("note");
  }
  set note(value) {
    this.__set("note", value);
  }
  /**
   * _URL addresses._
   *
   * When updating this property, you must set the entire array of URL addresses that you would like to store on the contact. The "identifier" key is optional.
   *
   * @type {Array<{ [key: string]: string }>}
   */
  get urlAddresses() {
    return this.__get("urlAddresses");
  }
  set urlAddresses(value) {
    this.__set("urlAddresses", value);
  }
  /**
   * _Dates._
   *
   * When updating this property, you must set the entire array of dates that you would like to store on the contact. The "identifier" key is optional.
   *
   * @type {Array<{ [key: string]: any }>}
   */
  get dates() {
    return this.__get("dates");
  }
  set dates(value) {
    this.__set("dates", value);
  }
  /**
   * _Name of the organization associated with the contact._
   */
  get organizationName() {
    return this.__get("organizationName");
  }
  set organizationName(value) {
    this.__set("organizationName", value);
  }
  /**
   * _Name of the department associated with the contact._
   */
  get departmentName() {
    return this.__get("departmentName");
  }
  set departmentName(value) {
    this.__set("departmentName", value);
  }
  /**
   * _The contact's job title._
   */
  get jobTitle() {
    return this.__get("jobTitle");
  }
  set jobTitle(value) {
    this.__set("jobTitle", value);
  }
  /**
   * _Whether or not name prefix is available._
   *
   * The `namePrefix` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isNamePrefixAvailable() {
    return this.__get("isNamePrefixAvailable");
  }
  set isNamePrefixAvailable(value) {
    this.__set("isNamePrefixAvailable", value);
  }
  /**
   * _Whether or not given name is available._
   *
   * The `givenName` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isGiveNameAvailable() {
    return this.__get("isGiveNameAvailable");
  }
  set isGiveNameAvailable(value) {
    this.__set("isGiveNameAvailable", value);
  }
  /**
   * _Whether or not middle name is available._
   *
   * The `middleName` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isMiddleNameAvailable() {
    return this.__get("isMiddleNameAvailable");
  }
  set isMiddleNameAvailable(value) {
    this.__set("isMiddleNameAvailable", value);
  }
  /**
   * _Whether or not family name is available._
   *
   * The `familyName` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isFamilyNameAvailable() {
    return this.__get("isFamilyNameAvailable");
  }
  set isFamilyNameAvailable(value) {
    this.__set("isFamilyNameAvailable", value);
  }
  /**
   * _Whether or not nickname is available._
   *
   * The `nickname` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isNicknameAvailable() {
    return this.__get("isNicknameAvailable");
  }
  set isNicknameAvailable(value) {
    this.__set("isNicknameAvailable", value);
  }
  /**
   * _Whether or not birthday is available._
   *
   * The `birthday` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isBirthdayAvailable() {
    return this.__get("isBirthdayAvailable");
  }
  set isBirthdayAvailable(value) {
    this.__set("isBirthdayAvailable", value);
  }
  /**
   * _Whether or not email addresses are available._
   *
   * The `emailAddresses` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isEmailAddressesAvailable() {
    return this.__get("isEmailAddressesAvailable");
  }
  set isEmailAddressesAvailable(value) {
    this.__set("isEmailAddressesAvailable", value);
  }
  /**
   * _Whether or not phone numbers are available._
   *
   * The `phoneNumbers` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isPhoneNumbersAvailable() {
    return this.__get("isPhoneNumbersAvailable");
  }
  set isPhoneNumbersAvailable(value) {
    this.__set("isPhoneNumbersAvailable", value);
  }
  /**
   * _Whether or not postal addresses are available._
   *
   * The `postalAddresses` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isPostalAddressesAvailable() {
    return this.__get("isPostalAddressesAvailable");
  }
  set isPostalAddressesAvailable(value) {
    this.__set("isPostalAddressesAvailable", value);
  }
  /**
   * _Whether or not social profiles are available._
   *
   * The `socialProfiles` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isSocialProfilesAvailable() {
    return this.__get("isSocialProfilesAvailable");
  }
  set isSocialProfilesAvailable(value) {
    this.__set("isSocialProfilesAvailable", value);
  }
  /**
   * _Whether or not image is available._
   *
   * The `image` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isImageAvailable() {
    return this.__get("isImageAvailable");
  }
  set isImageAvailable(value) {
    this.__set("isImageAvailable", value);
  }
  /**
   * _Whether or not note is available._
   *
   * The `note` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isNoteAvailable() {
    return this.__get("isNoteAvailable");
  }
  set isNoteAvailable(value) {
    this.__set("isNoteAvailable", value);
  }
  /**
   * _Whether or not URL addresses are available._
   *
   * The `urlAddresses` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isURLAddressesAvailable() {
    return this.__get("isURLAddressesAvailable");
  }
  set isURLAddressesAvailable(value) {
    this.__set("isURLAddressesAvailable", value);
  }
  /**
   * _Whether or not organization name is available._
   *
   * The `organizationName` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isOrganizationNameAvailable() {
    return this.__get("isOrganizationNameAvailable");
  }
  set isOrganizationNameAvailable(value) {
    this.__set("isOrganizationNameAvailable", value);
  }
  /**
   * _Whether or not department name is available._
   *
   * The `departmentName` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isDepartmentNameAvailable() {
    return this.__get("isDepartmentNameAvailable");
  }
  set isDepartmentNameAvailable(value) {
    this.__set("isDepartmentNameAvailable", value);
  }
  /**
   * _Whether or not job title is available._
   *
   * The `jobTitle` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isJobTitleAvailable() {
    return this.__get("isJobTitleAvailable");
  }
  set isJobTitleAvailable(value) {
    this.__set("isJobTitleAvailable", value);
  }
  /**
   * _Whether or not dates are available._
   *
   * The `date` property may not be available if the container does not support it. In that case any value set on the property will be ignored.
   */
  get isDatesAvailable() {
    return this.__get("isDatesAvailable");
  }
  set isDatesAvailable(value) {
    this.__set("isDatesAvailable", value);
  }
  /**
   * @param containers readonly ContactsContainer[]
   * @returns {Promise<Contact[]>}
   */
  static all(_containers) {
    throw new Error("Not implemented");
  }
  /**
   * @param groups readonly ContactsGroup[]
   * @returns {Promise<Contact[]>}
   */
  static inGroups(_groups) {
    throw new Error("Not implemented");
  }
  /**
   * @param contact Contact
   * @param containerIdentifier string
   */
  static add(_contact, _containerIdentifier) {
    throw new Error("Not implemented");
  }
  /**
   * @param contact Contact
   */
  static update(_contact) {
    throw new Error("Not implemented");
  }
  /**
   * @param contact Contact
   */
  static delete(_contact) {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<void>}
   */
  static persistChanges() {
    throw new Error("Not implemented");
  }
}
class AbsContactsContainer extends ScriptableObject {
  static __className = "ContactsContainer";
  /**
   * _Identifier of the contacts container._
   */
  get identifier() {
    return this.__get("identifier");
  }
  set identifier(value) {
    this.__set("identifier", value);
  }
  /**
   * _Name of the contacts container._
   */
  get name() {
    return this.__get("name");
  }
  set name(value) {
    this.__set("name", value);
  }
  /**
   * @returns {Promise<ContactsContainer>}
   */
  static default() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<ContactsContainer[]>}
   */
  static all() {
    throw new Error("Not implemented");
  }
  /**
   * @param identifier string
   * @returns {Promise<ContactsContainer>}
   */
  static withIdentifier(_identifier) {
    throw new Error("Not implemented");
  }
}
class AbsContactsGroup extends ScriptableObject {
  static __className = "ContactsGroup";
  /**
   * _Identifier of the contacts group._
   */
  get identifier() {
    return this.__get("identifier");
  }
  set identifier(value) {
    this.__set("identifier", value);
  }
  /**
   * _Name of the contacts group._
   */
  get name() {
    return this.__get("name");
  }
  set name(value) {
    this.__set("name", value);
  }
  /**
   * @param contact Contact
   */
  addMember(_contact) {
    throw new Error("Not implemented");
  }
  /**
   * @param contact Contact
   */
  removeMember(_contact) {
    throw new Error("Not implemented");
  }
  /**
   * @param containers readonly ContactsContainer[]
   * @returns {Promise<ContactsGroup[]>}
   */
  static all(_containers) {
    throw new Error("Not implemented");
  }
  /**
   * @param group ContactsGroup
   * @param containerIdentifier string
   */
  static add(_group, _containerIdentifier) {
    throw new Error("Not implemented");
  }
  /**
   * @param group ContactsGroup
   */
  static update(_group) {
    throw new Error("Not implemented");
  }
  /**
   * @param group ContactsGroup
   */
  static delete(_group) {
    throw new Error("Not implemented");
  }
}
class AbsData extends ScriptableObject {
  static __className = "Data";
  /**
   * @returns {string}
   */
  toRawString() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {string}
   */
  toBase64String() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {number[]}
   */
  getBytes() {
    throw new Error("Not implemented");
  }
  /**
   * @param string string
   * @returns {Data}
   */
  static fromString(_string) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {Data}
   */
  static fromFile(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param base64String string
   * @returns {Data}
   */
  static fromBase64String(_base64String) {
    throw new Error("Not implemented");
  }
  /**
   * @param image Image
   * @returns {Data}
   */
  static fromJPEG(_image) {
    throw new Error("Not implemented");
  }
  /**
   * @param image Image
   * @returns {Data}
   */
  static fromPNG(_image) {
    throw new Error("Not implemented");
  }
  /**
   * @param bytes readonly number[]
   * @returns {Data}
   */
  static fromBytes(_bytes) {
    throw new Error("Not implemented");
  }
}
class AbsDateFormatter extends ScriptableObject {
  static __className = "DateFormatter";
  /**
   * _Date format to be used by the formatter._
   *
   * Sets a fixed format to be used by the formatter. For example the date "2019-08-26 16:47" can be represented using the format "yyyy-MM-dd HH:mm".
   *
   * When converting dates to strings, it's advised to use some of the predefined formats for dates and times that can be applied using functions on the formatter, e.g.
   * `useMediumDateStyle()` and `useMediumTimeStyle()`.
   *
   * Year:
   *
   * *   `y`: Year with no padding. Example: "2019"
   * *   `yy`: Year with two zeros. Adds padding if necessary. Example: "19"
   * *   `yyyy`: Year with a minimum of four digits. Adds padding if necessary. Example: "2019"
   *
   * Quarter:
   *
   * *   `Q`: Quarter of the year. Example: "4"
   * *   `QQQQ`: Quarter spelled out. Example: "4th quarter"
   *
   * Month:
   *
   * *   `M`: Numeric month of the year. Example: "1"
   * *   `MM`: Numeric month of the year. Adds padding if necessary. Example: "01"
   * *   `MMM`: Shorthand name of the month. Example: "Jan"
   * *   `MMMM`: Full name of the month. Example: "January"
   * *   `MMMMM`: Narrow name of the month. Example: "J"
   *
   * Day:
   *
   * *   `d`: Day of the month. Example: "9"
   * *   `dd`: Day of the month. Adds padding if necessary. Example: "09"
   * *   `F`: Day of the week. Example: "3rd Friday in August"
   * *   `E`: Day of the week. Example: "Fri"
   * *   `EEEE`: Full name of the day. Example: "Friday"
   * *   `EEEEE`: Narrow day of the week. Example: "F"
   *
   * Hour:
   *
   * *   `h`: Hour on a 12-hour clock. Example: "9"
   * *   `hh`: Hour on a 12-hour clock. Adds padding if necessary. Example: "09"
   * *   `H`: Hour on a 24-hour clock. Example: "21"
   * *   `HH`: Hour on a 24-hour clock. Adds padding if necessary. Example: "21"
   * *   `a`: AM/PM for times on a 12-hour clock. Example: "PM"
   *
   * Minute:
   *
   * *   `m`: Minute. Example: "7"
   * *   `mm`: Minute. Adds padding if necessary. Example: "07"
   *
   * Second:
   *
   * *   `s`: Seconds. Example: "4"
   * *   `ss`: Seconds. Adds padding if necessary. Example: "04"
   * *   `SSS`: Milliseconds. Example: "384"
   *
   * Time zone:
   *
   * *   `zzz`: Three letter name of the time zone. Falls back to GMT-08:00 if the name is unknown. Example: "CST"
   * *   `zzzz`: Full name of the time zone. Falls back to GMT-08:00 if the name is unknown. Example: "Central Standard Time"
   * *   `Z`: Time zone in RFC 822 GMT format. Also matches a literal Z for Zulu (UTC) time. Example: "-0600"
   * *   `ZZZZ`: Time zone with abbreviation and offset. Example: "CST-06:00"
   * *   `ZZZZZ`: Time zone in ISO 8601 format. Example: "-06:00"
   *
   * A great resource for experimenting with date formats is nsdateformatter.com developed by Ben Scheirman.
   */
  get dateFormat() {
    return this.__get("dateFormat");
  }
  set dateFormat(value) {
    this.__set("dateFormat", value);
  }
  /**
   * _Locale to use when formatting._
   *
   * The locale should be specified using a string identifier, e.g. "en", "it" or "da". When no locale is set, the formatter will use the current locale of the device.
   */
  get locale() {
    return this.__get("locale");
  }
  set locale(value) {
    this.__set("locale", value);
  }
  /**
   * @param date Date
   * @returns {string}
   */
  string(_date) {
    throw new Error("Not implemented");
  }
  /**
   * @param str string
   * @returns {Date}
   */
  date(_str) {
    throw new Error("Not implemented");
  }
  /**
   */
  useNoDateStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  useShortDateStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  useMediumDateStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  useLongDateStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  useFullDateStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  useNoTimeStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  useShortTimeStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  useMediumTimeStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  useLongTimeStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  useFullTimeStyle() {
    throw new Error("Not implemented");
  }
}
class AbsDatePicker extends ScriptableObject {
  static __className = "DatePicker";
  /**
   * _Minimum date that is selected in the picker._
   *
   * The minimum date, along with the maximum date, specifies the valid date range. The minimum and maximum dates are ignored if the minimum date is greater than the maximum date. The
   * dates are also ignored in countdown-timer mode.
   */
  get minimumDate() {
    return this.__get("minimumDate");
  }
  set minimumDate(value) {
    this.__set("minimumDate", value);
  }
  /**
   * _Maximum date that is selected in the picker._
   *
   * The maximum date, along with the minimum date, specifies the valid date range. The minimum and maximum dates are ignored if the minimum date is greater than the maximum date. The
   * dates are also ignored in countdown-timer mode.
   */
  get maximumDate() {
    return this.__get("maximumDate");
  }
  set maximumDate(value) {
    this.__set("maximumDate", value);
  }
  /**
   * _Countdown duration displayed by the date picker._
   *
   * Use this property to get and set the duration of a countdown when calling the `pickCountDownDuration()` function to present the picker. The default value is zero and the maximum
   * value is 23:59 (86,399 seconds).
   */
  get countdownDuration() {
    return this.__get("countdownDuration");
  }
  set countdownDuration(value) {
    this.__set("countdownDuration", value);
  }
  /**
   * _Interval at which the date picker displays minutes._
   *
   * Use the property to set the interval of the minute wheel. The default and minimum value is 1 and the maximum value is 30.
   */
  get minuteInterval() {
    return this.__get("minuteInterval");
  }
  set minuteInterval(value) {
    this.__set("minuteInterval", value);
  }
  /**
   * _The initially selected date._
   *
   * Use this property to specify the initially selected date and time when picking a date, a time or both using date picker. If no date is specified, the current date and time will be
   * selected initially.
   *
   * Be aware that this property does not hold the selected date after the date picker has been dismissed. The promises returned by `pickTime()`, `pickDate()` and `PickDateAndTime()`
   * carries the selected date.
   */
  get initialDate() {
    return this.__get("initialDate");
  }
  set initialDate(value) {
    this.__set("initialDate", value);
  }
  /**
   * @returns {Promise<Date>}
   */
  pickTime() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<Date>}
   */
  pickDate() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<Date>}
   */
  pickDateAndTime() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<number>}
   */
  pickCountdownDuration() {
    throw new Error("Not implemented");
  }
}
class AbsDrawContext extends ScriptableObject {
  static __className = "DrawContext";
  /**
   * _Size of canvas._
   *
   * Specifies the size of the canvas on which you are drawing. The image returned by getImage() will have this exact size, except if respectScreenScale is true.
   */
  get size() {
    return this.__get("size");
  }
  set size(value) {
    this.__set("size", value);
  }
  /**
   * _Enable to respect the scale of the screen._
   *
   * Devices have a screen scale that is used to convert between the logical coordinate space and the device coordinate space. For example, retina screens have a screen scale of 2 or 3
   * meaning that one point in the logical coordinate space is represented by four or nine pixels. Respecting the screen scale will multiply the specified size of the canvas by the
   * screen scale. For example a canvas of size 200 by 200 will be 600 by 600 when the image is rendered on a retina screen with a screen scale of 3. When respecting the screen scale is
   * disabled, you may experience that your images looks blurry because essentially the size you have specified will be stretched when rendered on the screen. Default is false.
   */
  get respectScreenScale() {
    return this.__get("respectScreenScale");
  }
  set respectScreenScale(value) {
    this.__set("respectScreenScale", value);
  }
  /**
   * _Determines whether the context is opaque._
   *
   * When enabled your image will be rendered opaque. Default is true.
   */
  get opaque() {
    return this.__get("opaque");
  }
  set opaque(value) {
    this.__set("opaque", value);
  }
  /**
   * @returns {Image}
   */
  getImage() {
    throw new Error("Not implemented");
  }
  /**
   * @param image Image
   * @param rect Rect
   */
  drawImageInRect(_image, _rect) {
    throw new Error("Not implemented");
  }
  /**
   * @param image Image
   * @param point Point
   */
  drawImageAtPoint(_image, _point) {
    throw new Error("Not implemented");
  }
  /**
   * @param color Color
   */
  setFillColor(_color) {
    throw new Error("Not implemented");
  }
  /**
   * @param color Color
   */
  setStrokeColor(_color) {
    throw new Error("Not implemented");
  }
  /**
   * @param width number
   */
  setLineWidth(_width) {
    throw new Error("Not implemented");
  }
  /**
   * @param rect Rect
   */
  fill(_rect) {
    throw new Error("Not implemented");
  }
  /**
   * @param rect Rect
   */
  fillRect(_rect) {
    throw new Error("Not implemented");
  }
  /**
   * @param rect Rect
   */
  fillEllipse(_rect) {
    throw new Error("Not implemented");
  }
  /**
   * @param rect Rect
   */
  stroke(_rect) {
    throw new Error("Not implemented");
  }
  /**
   * @param rect Rect
   */
  strokeRect(_rect) {
    throw new Error("Not implemented");
  }
  /**
   * @param rect Rect
   */
  strokeEllipse(_rect) {
    throw new Error("Not implemented");
  }
  /**
   * @param path Path
   */
  addPath(_path) {
    throw new Error("Not implemented");
  }
  /**
   */
  strokePath() {
    throw new Error("Not implemented");
  }
  /**
   */
  fillPath() {
    throw new Error("Not implemented");
  }
  /**
   * @param text string
   * @param pos Point
   */
  drawText(_text, _pos) {
    throw new Error("Not implemented");
  }
  /**
   * @param text string
   * @param rect Rect
   */
  drawTextInRect(_text, _rect) {
    throw new Error("Not implemented");
  }
  /**
   * @param font Font
   */
  setFont(_font) {
    throw new Error("Not implemented");
  }
  /**
   * @param color Color
   */
  setTextColor(_color) {
    throw new Error("Not implemented");
  }
  /**
   */
  setTextAlignedLeft() {
    throw new Error("Not implemented");
  }
  /**
   */
  setTextAlignedCenter() {
    throw new Error("Not implemented");
  }
  /**
   */
  setTextAlignedRight() {
    throw new Error("Not implemented");
  }
}
class AbsFileManager extends ScriptableObject {
  static __className = "FileManager";
  /**
   * @param filePath string
   * @returns {Data}
   */
  read(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {string}
   */
  readString(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {Image}
   */
  readImage(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @param content Data
   */
  write(_filePath, _content) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @param content string
   */
  writeString(_filePath, _content) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @param image Image
   */
  writeImage(_filePath, _image) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   */
  remove(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param sourceFilePath string
   * @param destinationFilePath string
   */
  move(_sourceFilePath, _destinationFilePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param sourceFilePath string
   * @param destinationFilePath string
   */
  copy(_sourceFilePath, _destinationFilePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {boolean}
   */
  fileExists(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param path string
   * @returns {boolean}
   */
  isDirectory(_path) {
    throw new Error("Not implemented");
  }
  /**
   * @param path string
   * @param intermediateDirectories boolean
   */
  createDirectory(_path, _intermediateDirectories) {
    throw new Error("Not implemented");
  }
  /**
   * @returns {string}
   */
  temporaryDirectory() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {string}
   */
  cacheDirectory() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {string}
   */
  documentsDirectory() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {string}
   */
  libraryDirectory() {
    throw new Error("Not implemented");
  }
  /**
   * @param lhsPath string
   * @param rhsPath string
   * @returns {string}
   */
  joinPath(_lhsPath, _rhsPath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {string[]}
   */
  allTags(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @param tag string
   */
  addTag(_filePath, _tag) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @param tag string
   */
  removeTag(_filePath, _tag) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @param name string
   * @returns {string}
   */
  readExtendedAttribute(_filePath, _name) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @param value string
   * @param name string
   */
  writeExtendedAttribute(_filePath, _value, _name) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @param name string
   */
  removeExtendedAttribute(_filePath, _name) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {string[]}
   */
  allExtendedAttributes(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {string}
   */
  getUTI(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param directoryPath string
   * @returns {string[]}
   */
  listContents(_directoryPath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @param includeFileExtension boolean
   * @returns {string}
   */
  fileName(_filePath, _includeFileExtension) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {string}
   */
  fileExtension(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param name string
   * @returns {string}
   */
  bookmarkedPath(_name) {
    throw new Error("Not implemented");
  }
  /**
   * @param name string
   * @returns {boolean}
   */
  bookmarkExists(_name) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {Promise<void>}
   */
  downloadFileFromiCloud(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {boolean}
   */
  isFileStoredIniCloud(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {boolean}
   */
  isFileDownloaded(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {Date}
   */
  creationDate(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {Date}
   */
  modificationDate(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @returns {number}
   */
  fileSize(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @returns {FileManager.AllFileBookmarks[]}
   */
  allFileBookmarks() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {FileManager}
   */
  static local() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {FileManager}
   */
  static iCloud() {
    throw new Error("Not implemented");
  }
}
class AbsFont extends ScriptableObject {
  static __className = "Font";
  /**
   * @returns {Font}
   */
  static largeTitle() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Font}
   */
  static title1() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Font}
   */
  static title2() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Font}
   */
  static title3() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Font}
   */
  static headline() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Font}
   */
  static subheadline() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Font}
   */
  static body() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Font}
   */
  static callout() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Font}
   */
  static footnote() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Font}
   */
  static caption1() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Font}
   */
  static caption2() {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static systemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static ultraLightSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static thinSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static lightSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static regularSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static mediumSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static semiboldSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static boldSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static heavySystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static blackSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static italicSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static ultraLightMonospacedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static thinMonospacedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static lightMonospacedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static regularMonospacedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static mediumMonospacedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static semiboldMonospacedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static boldMonospacedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static heavyMonospacedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static blackMonospacedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static ultraLightRoundedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static thinRoundedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static lightRoundedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static regularRoundedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static mediumRoundedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static semiboldRoundedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static boldRoundedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static heavyRoundedSystemFont(_size) {
    throw new Error("Not implemented");
  }
  /**
   * @param size number
   * @returns {Font}
   */
  static blackRoundedSystemFont(_size) {
    throw new Error("Not implemented");
  }
}
class AbsImage extends ScriptableObject {
  static __className = "Image";
  /**
   * _Size of the image in pixels._
   */
  get size() {
    return this.__get("size");
  }
  set size(value) {
    this.__set("size", value);
  }
  /**
   * @param filePath string
   * @returns {Image}
   */
  static fromFile(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param data Data
   * @returns {Image}
   */
  static fromData(_data) {
    throw new Error("Not implemented");
  }
}
class AbsLinearGradient extends ScriptableObject {
  static __className = "LinearGradient";
  /**
   * _Colors of the gradient._
   *
   * The array of colors should include the same amount of elements as the gradients `locations` property.
   */
  get colors() {
    return this.__get("colors");
  }
  set colors(value) {
    this.__set("colors", value);
  }
  /**
   * _Locations of each color._
   *
   * Each location should be a value in the range of 0 to 1 and indicates the location of each color in the gradients `colors` array.
   *
   * The array of locations should include the same amount of elements as the gradients `colors` property.
   */
  get locations() {
    return this.__get("locations");
  }
  set locations(value) {
    this.__set("locations", value);
  }
  /**
   * _Point to start the gradient._
   *
   * The normalized starting point of the gradient. The `endPoint` and `startPoint` together controls the direction of the gradient. The X and Y component should each range from 0 to 1.
   * Defaults to (0, 1).
   */
  get startPoint() {
    return this.__get("startPoint");
  }
  set startPoint(value) {
    this.__set("startPoint", value);
  }
  /**
   * _Point to end the gradient._
   *
   * The normalized ending point of the gradient. The `endPoint` and `startPoint` together controls the direction of the gradient. The X and Y component should each range from 0 to 1.
   * Defaults to (0, 1).
   */
  get endPoint() {
    return this.__get("endPoint");
  }
  set endPoint(value) {
    this.__set("endPoint", value);
  }
}
class AbsListWidget extends ScriptableObject {
  static __className = "ListWidget";
  /**
   * _Background color of the widget._
   *
   * Defaults to a solid color in widgets placed on the Home Screen and a transparent color placed on the Lock Screen.
   */
  get backgroundColor() {
    return this.__get("backgroundColor");
  }
  set backgroundColor(value) {
    this.__set("backgroundColor", value);
  }
  /**
   * _Background image._
   */
  get backgroundImage() {
    return this.__get("backgroundImage");
  }
  set backgroundImage(value) {
    this.__set("backgroundImage", value);
  }
  /**
   * _Background gradient._
   */
  get backgroundGradient() {
    return this.__get("backgroundGradient");
  }
  set backgroundGradient(value) {
    this.__set("backgroundGradient", value);
  }
  /**
   * _Whether to use an accessory widget background._
   *
   * Enable to add an adaptive background that provides a standard appearance based on the widget's environment. Defaults to false.
   *
   * This is only available starting from iOS 16.
   */
  get addAccessoryWidgetBackground() {
    return this.__get("addAccessoryWidgetBackground");
  }
  set addAccessoryWidgetBackground(value) {
    this.__set("addAccessoryWidgetBackground", value);
  }
  /**
   * _Spacing between elements._
   *
   * Specifies the spacing between elements in the widget. You can also use the `addSpacer()` function on the widget to add spacing between elements. Defaults to 0.
   */
  get spacing() {
    return this.__get("spacing");
  }
  set spacing(value) {
    this.__set("spacing", value);
  }
  /**
   * _URL to open._
   *
   * The URL will be opened when the widget is tapped. This will override any behavior defined in the configuration of the widget. E.g. if the widget is configured to run the script
   * when interacting with the widget but a URL is set the URL will take precedence.
   */
  get url() {
    return this.__get("url");
  }
  set url(value) {
    this.__set("url", value);
  }
  /**
   * _Earliest date to refresh the widget._
   *
   * The property indicates when the widget can be refreshed again. The widget will not be refreshed before the date has been reached. It is not guaranteed that the widget will refresh
   * at exactly the specified date.
   *
   * The refresh rate of a widget is partly up to iOS/iPadOS. For example, a widget may not refresh if the device is low on battery or the user is rarely looking at the widget.
   *
   * When the property is `null` the default refresh interval is used. Defaults to `null`.
   */
  get refreshAfterDate() {
    return this.__get("refreshAfterDate");
  }
  set refreshAfterDate(value) {
    this.__set("refreshAfterDate", value);
  }
  /**
   * @param text string
   * @returns {WidgetText}
   */
  addText(_text) {
    throw new Error("Not implemented");
  }
  /**
   * @param date Date
   * @returns {WidgetDate}
   */
  addDate(_date) {
    throw new Error("Not implemented");
  }
  /**
   * @param image Image
   * @returns {WidgetImage}
   */
  addImage(_image) {
    throw new Error("Not implemented");
  }
  /**
   * @param length number
   * @returns {WidgetSpacer}
   */
  addSpacer(_length) {
    throw new Error("Not implemented");
  }
  /**
   * @returns {WidgetStack}
   */
  addStack() {
    throw new Error("Not implemented");
  }
  /**
   * @param top number
   * @param leading number
   * @param bottom number
   * @param trailing number
   */
  setPadding(_top, _leading, _bottom, _trailing) {
    throw new Error("Not implemented");
  }
  /**
   */
  useDefaultPadding() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<void>}
   */
  presentSmall() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<void>}
   */
  presentMedium() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<void>}
   */
  presentLarge() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<void>}
   */
  presentExtraLarge() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<void>}
   */
  presentAccessoryInline() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<void>}
   */
  presentAccessoryCircular() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<void>}
   */
  presentAccessoryRectangular() {
    throw new Error("Not implemented");
  }
}
class AbsMail extends ScriptableObject {
  static __className = "Mail";
  /**
   * _Recipients of the mail._
   *
   * Array of recipients to send the mail to. Elements in the array should be e-mail addresses. You will have a chance to modify this before the mail is sent.
   */
  get toRecipients() {
    return this.__get("toRecipients");
  }
  set toRecipients(value) {
    this.__set("toRecipients", value);
  }
  /**
   * _Recipients to set CC on the mail._
   *
   * Array of recipients to set as CC on the mail. Elements in the array should be e-mail addresses. You will have a chance to modify this before the mail is sent.
   */
  get ccRecipients() {
    return this.__get("ccRecipients");
  }
  set ccRecipients(value) {
    this.__set("ccRecipients", value);
  }
  /**
   * _Recipients to set BCC on the mail._
   *
   * Array of recipients to set as BCC on the mail. Elements in the array should be e-mail addresses. You will have a chance to modify this before the mail is sent.
   */
  get bccRecipients() {
    return this.__get("bccRecipients");
  }
  set bccRecipients(value) {
    this.__set("bccRecipients", value);
  }
  /**
   * _Subject of the mail._
   *
   * Subject of the mail to send. You will have a chance to modify this before the mail is sent.
   */
  get subject() {
    return this.__get("subject");
  }
  set subject(value) {
    this.__set("subject", value);
  }
  /**
   * _Body of the mail._
   *
   * Body of the mail to send. You will have a chance to modify this before the mail is sent.
   */
  get body() {
    return this.__get("body");
  }
  set body(value) {
    this.__set("body", value);
  }
  /**
   * _Whether body is HTML._
   *
   * Set to true if the body of the mail is HTML. Defaults to false.
   */
  get isBodyHTML() {
    return this.__get("isBodyHTML");
  }
  set isBodyHTML(value) {
    this.__set("isBodyHTML", value);
  }
  /**
   * _Preferred email address to use in the from field._
   *
   * Sets the preferred email addressed to use when sending the mail. If no account with the preferred email address is set up, the default email address is used.
   */
  get preferredSendingEmailAddress() {
    return this.__get("preferredSendingEmailAddress");
  }
  set preferredSendingEmailAddress(value) {
    this.__set("preferredSendingEmailAddress", value);
  }
  /**
   * @returns {Promise<void>}
   */
  send() {
    throw new Error("Not implemented");
  }
  /**
   * @param image Image
   */
  addImageAttachment(_image) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   */
  addFileAttachment(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param data Data
   * @param mimeType string
   * @param filename string
   */
  addDataAttachment(_data, _mimeType, _filename) {
    throw new Error("Not implemented");
  }
}
class AbsMessage extends ScriptableObject {
  static __className = "Message";
  /**
   * _Recipients of the message._
   *
   * Array of recipients to send the message to. Elements in the array should be phone numbers. You will have a chance to modify this before the message is sent.
   */
  get recipients() {
    return this.__get("recipients");
  }
  set recipients(value) {
    this.__set("recipients", value);
  }
  /**
   * _Body of the message._
   *
   * Body of the message to send. You will have a chance to modify this before the message is sent.
   */
  get body() {
    return this.__get("body");
  }
  set body(value) {
    this.__set("body", value);
  }
  /**
   * @returns {Promise<void>}
   */
  send() {
    throw new Error("Not implemented");
  }
  /**
   * @param image Image
   */
  addImageAttachment(_image) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   */
  addFileAttachment(_filePath) {
    throw new Error("Not implemented");
  }
  /**
   * @param data Data
   * @param uti string
   * @param filename string
   */
  addDataAttachment(_data, _uti, _filename) {
    throw new Error("Not implemented");
  }
}
class AbsNotification extends ScriptableObject {
  static __className = "Notification";
  /**
   * _Identifier of the notification._
   *
   * To reschedule a notification, use the identifier of an existing notification.
   */
  get identifier() {
    return this.__get("identifier");
  }
  set identifier(value) {
    this.__set("identifier", value);
  }
  /**
   * _Title of the notification._
   */
  get title() {
    return this.__get("title");
  }
  set title(value) {
    this.__set("title", value);
  }
  /**
   * _Subtitle of the notification._
   */
  get subtitle() {
    return this.__get("subtitle");
  }
  set subtitle(value) {
    this.__set("subtitle", value);
  }
  /**
   * _Body of the notification._
   */
  get body() {
    return this.__get("body");
  }
  set body(value) {
    this.__set("body", value);
  }
  /**
   * _Preferred height of the notification._
   *
   * By default Scriptable attempts to determine an appropriate height for your notification. If you want to override the default behavior, you can specify a preferred content height.
   * The preferred content height is only used when running a script inside the notification, i.e. when `scriptName` is not null. iOS may limit the height of the notification in which
   * case the preferred content height is not guaranteed to be respected.
   */
  get preferredContentHeight() {
    return this.__get("preferredContentHeight");
  }
  set preferredContentHeight(value) {
    this.__set("preferredContentHeight", value);
  }
  /**
   * _Number to display in the app icon's badge._
   *
   * When the number is zero, no badge is displayed. When the number is greater than zero, the number is displayed in the app icon's badge. Setting the value to null, will leave the
   * badge unchanged. The default value is null.
   */
  get badge() {
    return this.__get("badge");
  }
  set badge(value) {
    this.__set("badge", value);
  }
  /**
   * _Identifier for grouping the notification._
   *
   * Notifications are grouped by the identifier on the Home Screen and in the Notification Center.
   */
  get threadIdentifier() {
    return this.__get("threadIdentifier");
  }
  set threadIdentifier(value) {
    this.__set("threadIdentifier", value);
  }
  /**
   * _Custom information._
   *
   * Store any custom information for the notification. This can be accessed from the `Notification.opened` property when a script is run from a notification.
   *
   * @type {{ [key: string]: any }}
   */
  get userInfo() {
    return this.__get("userInfo");
  }
  set userInfo(value) {
    this.__set("userInfo", value);
  }
  /**
  * _Sound of the notification._
  *
  * Set to null if you do not want any sound. Set to one of the following values if you want a sound.
  *
  * *   default
  * *   accept
  * *   alert
  * *   complete
  * *   event
  * *   failure
  * *   piano\_error
  * *   piano\_success
  * *   popup
  *
  * By default the notification is delivered with no sound.
  *
  * @type {| "default"
         | "accept"
         | "alert"
         | "complete"
         | "event"
         | "failure"
         | "piano_error"
         | "piano_success"
         | "popup"}
    */
  get sound() {
    return this.__get("sound");
  }
  set sound(value) {
    this.__set("sound", value);
  }
  /**
   * _URL to open when notification is tapped._
   *
   * The Scriptable application will open the URL when the notification is tapped. This can be a URL that uses Scriptables URL scheme, the URL scheme of another application or a website
   * URL.
   */
  get openURL() {
    return this.__get("openURL");
  }
  set openURL(value) {
    this.__set("openURL", value);
  }
  /**
   * _Delivery date of the notification._
   *
   * If the notification has already been delivered, for example because it was fetched using `Notification.allDelivered()`, the deliveryDate will be populated. Otherwise it will be
   * null.
   *
   * The property cannot be set. In order to specify a future delivery date for a notification, see the `setTriggerDate` function. For recurring notifications, see the `setDailyTrigger`
   * and `setWeeklyTrigger` functions.
   */
  get deliveryDate() {
    return this.__get("deliveryDate");
  }
  set deliveryDate(value) {
    this.__set("deliveryDate", value);
  }
  /**
   * _Next trigger date of the notification._
   *
   * The next trigger date is the point in time where the next notification will be delivered.
   *
   * The property cannot be set. In order to specify a future delivery date for a notification, see the `setTriggerDate` function. For recurring notifications, see the `setDailyTrigger`
   * and `setWeeklyTrigger` functions.
   */
  get nextTriggerDate() {
    return this.__get("nextTriggerDate");
  }
  set nextTriggerDate(value) {
    this.__set("nextTriggerDate", value);
  }
  /**
   * _Name of script to run in rich notification._
   *
   * When notification is force touched or long pressed, Scriptable can run a script inside the notification without opening the app. Set the `scriptName` to a name of an existing
   * script to run it inside the notification.
   */
  get scriptName() {
    return this.__get("scriptName");
  }
  set scriptName(value) {
    this.__set("scriptName", value);
  }
  /**
   * _Actions added to the notification._
   *
   * An array of objects on the following form:
   *
   * {
   * "title": "Open Website",
   * "url": "https://scriptable.app"
   * }
   *
   * To add a notification, use `Notification.addAction`.
   */
  get actions() {
    return this.__get("actions");
  }
  set actions(value) {
    this.__set("actions", value);
  }
  /**
   * @returns {Promise<void>}
   */
  schedule() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<void>}
   */
  remove() {
    throw new Error("Not implemented");
  }
  /**
   * @param date Date
   */
  setTriggerDate(_date) {
    throw new Error("Not implemented");
  }
  /**
   * @param hour number
   * @param minute number
   * @param repeats boolean
   */
  setDailyTrigger(_hour, _minute, _repeats) {
    throw new Error("Not implemented");
  }
  /**
   * @param weekday number
   * @param hour number
   * @param minute number
   * @param repeats boolean
   */
  setWeeklyTrigger(_weekday, _hour, _minute, _repeats) {
    throw new Error("Not implemented");
  }
  /**
   * @param title string
   * @param url string
   * @param destructive boolean
   */
  addAction(_title, _url, _destructive) {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<Notification[]>}
   */
  static allPending() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<Notification[]>}
   */
  static allDelivered() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<void>}
   */
  static removeAllPending() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<void>}
   */
  static removeAllDelivered() {
    throw new Error("Not implemented");
  }
  /**
   * @param identifiers readonly string[]
   * @returns {Promise<void>}
   */
  static removePending(_identifiers) {
    throw new Error("Not implemented");
  }
  /**
   * @param identifiers readonly string[]
   * @returns {Promise<void>}
   */
  static removeDelivered(_identifiers) {
    throw new Error("Not implemented");
  }
  /**
   */
  static resetCurrent() {
    throw new Error("Not implemented");
  }
}
class AbsPath extends ScriptableObject {
  static __className = "Path";
  /**
   * @param point Point
   */
  move(_point) {
    throw new Error("Not implemented");
  }
  /**
   * @param point Point
   */
  addLine(_point) {
    throw new Error("Not implemented");
  }
  /**
   * @param rect Rect
   */
  addRect(_rect) {
    throw new Error("Not implemented");
  }
  /**
   * @param rect Rect
   */
  addEllipse(_rect) {
    throw new Error("Not implemented");
  }
  /**
   * @param rect Rect
   * @param cornerWidth number
   * @param cornerHeight number
   */
  addRoundedRect(_rect, _cornerWidth, _cornerHeight) {
    throw new Error("Not implemented");
  }
  /**
   * @param point Point
   * @param control1 Point
   * @param control2 Point
   */
  addCurve(_point, _control1, _control2) {
    throw new Error("Not implemented");
  }
  /**
   * @param point Point
   * @param control Point
   */
  addQuadCurve(_point, _control) {
    throw new Error("Not implemented");
  }
  /**
   * @param points readonly Point[]
   */
  addLines(_points) {
    throw new Error("Not implemented");
  }
  /**
   * @param rects readonly Rect[]
   */
  addRects(_rects) {
    throw new Error("Not implemented");
  }
  /**
   */
  closeSubpath() {
    throw new Error("Not implemented");
  }
}
class AbsPoint extends ScriptableObject {
  static __className = "Point";
  /**
   * _X value._
   */
  get x() {
    return this.__get("x");
  }
  set x(value) {
    this.__set("x", value);
  }
  /**
   * _Y value._
   */
  get y() {
    return this.__get("y");
  }
  set y(value) {
    this.__set("y", value);
  }
}
class AbsRect extends ScriptableObject {
  static __className = "Rect";
  /**
   * _Minimum X value._
   *
   * The smallest x-coordinate in the rectangle.
   */
  get minX() {
    return this.__get("minX");
  }
  set minX(value) {
    this.__set("minX", value);
  }
  /**
   * _Minimum Y value._
   *
   * The smallest y-coordinate in the rectangle.
   */
  get minY() {
    return this.__get("minY");
  }
  set minY(value) {
    this.__set("minY", value);
  }
  /**
   * _Maximum X value._
   *
   * The greatest x-coordinate in the rectangle.
   */
  get maxX() {
    return this.__get("maxX");
  }
  set maxX(value) {
    this.__set("maxX", value);
  }
  /**
   * _Maximum Y value._
   *
   * The greatest y-coordinate in the rectangle.
   */
  get maxY() {
    return this.__get("maxY");
  }
  set maxY(value) {
    this.__set("maxY", value);
  }
  /**
   * _X value._
   *
   * The x-coordinate of the rectangle.
   */
  get x() {
    return this.__get("x");
  }
  set x(value) {
    this.__set("x", value);
  }
  /**
   * _Y value._
   *
   * The y-coordinate of the rectangle.
   */
  get y() {
    return this.__get("y");
  }
  set y(value) {
    this.__set("y", value);
  }
  /**
   * _Width of rectangle._
   *
   * The width of the rectangle.
   */
  get width() {
    return this.__get("width");
  }
  set width(value) {
    this.__set("width", value);
  }
  /**
   * _Height of rectangle._
   *
   * The height of the rectangle.
   */
  get height() {
    return this.__get("height");
  }
  set height(value) {
    this.__set("height", value);
  }
  /**
   * _Point that specifies the rectangles origin._
   *
   * The x- and y-coordinate that specifies the rectangles origin as a Point structure.
   */
  get origin() {
    return this.__get("origin");
  }
  set origin(value) {
    this.__set("origin", value);
  }
  /**
   * _Size of the rectangle._
   *
   * The width and height of the rectangle as a Size structure.
   */
  get size() {
    return this.__get("size");
  }
  set size(value) {
    this.__set("size", value);
  }
}
class AbsRecurrenceRule extends ScriptableObject {
  static __className = "RecurrenceRule";
  /**
   * @param interval number
   * @returns {RecurrenceRule}
   */
  static daily(_interval) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param endDate Date
   * @returns {RecurrenceRule}
   */
  static dailyEndDate(_interval, _endDate) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param occurrenceCount number
   * @returns {RecurrenceRule}
   */
  static dailyOccurrenceCount(_interval, _occurrenceCount) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @returns {RecurrenceRule}
   */
  static weekly(_interval) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param endDate Date
   * @returns {RecurrenceRule}
   */
  static weeklyEndDate(_interval, _endDate) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param occurrenceCount number
   * @returns {RecurrenceRule}
   */
  static weeklyOccurrenceCount(_interval, _occurrenceCount) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @returns {RecurrenceRule}
   */
  static monthly(_interval) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param endDate Date
   * @returns {RecurrenceRule}
   */
  static monthlyEndDate(_interval, _endDate) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param occurrenceCount number
   * @returns {RecurrenceRule}
   */
  static monthlyOccurrenceCount(_interval, _occurrenceCount) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @returns {RecurrenceRule}
   */
  static yearly(_interval) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param endDate Date
   * @returns {RecurrenceRule}
   */
  static yearlyEndDate(_interval, _endDate) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param occurrenceCount number
   * @returns {RecurrenceRule}
   */
  static yearlyOccurrenceCount(_interval, _occurrenceCount) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param daysOfTheWeek readonly number[]
   * @param setPositions readonly number[]
   * @returns {RecurrenceRule}
   */
  static complexWeekly(_interval, _daysOfTheWeek, _setPositions) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param daysOfTheWeek readonly number[]
   * @param setPositions readonly number[]
   * @param endDate Date
   * @returns {RecurrenceRule}
   */
  static complexWeeklyEndDate(_interval, _daysOfTheWeek, _setPositions, _endDate) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param daysOfTheWeek readonly number[]
   * @param setPositions readonly number[]
   * @param occurrenceCount number
   * @returns {RecurrenceRule}
   */
  static complexWeeklyOccurrenceCount(_interval, _daysOfTheWeek, _setPositions, _occurrenceCount) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param daysOfTheWeek readonly number[]
   * @param daysOfTheMonth readonly number[]
   * @param setPositions readonly number[]
   * @returns {RecurrenceRule}
   */
  static complexMonthly(_interval, _daysOfTheWeek, _daysOfTheMonth, _setPositions) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param daysOfTheWeek readonly number[]
   * @param daysOfTheMonth readonly number[]
   * @param setPositions readonly number[]
   * @param endDate Date
   * @returns {RecurrenceRule}
   */
  static complexMonthlyEndDate(_interval, _daysOfTheWeek, _daysOfTheMonth, _setPositions, _endDate) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param daysOfTheWeek readonly number[]
   * @param daysOfTheMonth readonly number[]
   * @param setPositions readonly number[]
   * @param occurrenceCount number
   * @returns {RecurrenceRule}
   */
  static complexMonthlyOccurrenceCount(_interval, _daysOfTheWeek, _daysOfTheMonth, _setPositions, _occurrenceCount) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param daysOfTheWeek readonly number[]
   * @param monthsOfTheYear readonly number[]
   * @param weeksOfTheYear readonly number[]
   * @param daysOfTheYear readonly number[]
   * @param setPositions readonly number[]
   * @returns {RecurrenceRule}
   */
  static complexYearly(_interval, _daysOfTheWeek, _monthsOfTheYear, _weeksOfTheYear, _daysOfTheYear, _setPositions) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param daysOfTheWeek readonly number[]
   * @param monthsOfTheYear readonly number[]
   * @param weeksOfTheYear readonly number[]
   * @param daysOfTheYear readonly number[]
   * @param setPositions readonly number[]
   * @param endDate Date
   * @returns {RecurrenceRule}
   */
  static complexYearlyEndDate(_interval, _daysOfTheWeek, _monthsOfTheYear, _weeksOfTheYear, _daysOfTheYear, _setPositions, _endDate) {
    throw new Error("Not implemented");
  }
  /**
   * @param interval number
   * @param daysOfTheWeek readonly number[]
   * @param monthsOfTheYear readonly number[]
   * @param weeksOfTheYear readonly number[]
   * @param daysOfTheYear readonly number[]
   * @param setPositions readonly number[]
   * @param occurrenceCount number
   * @returns {RecurrenceRule}
   */
  static complexYearlyOccurrenceCount(_interval, _daysOfTheWeek, _monthsOfTheYear, _weeksOfTheYear, _daysOfTheYear, _setPositions, _occurrenceCount) {
    throw new Error("Not implemented");
  }
}
class AbsRelativeDateTimeFormatter extends ScriptableObject {
  static __className = "RelativeDateTimeFormatter";
  /**
   * _Locale to use when formatting._
   *
   * The locale should be specified using a string identifier, e.g. "en", "it" or "da". When no locale is set, the formatter will use the current locale of the device.
   */
  get locale() {
    return this.__get("locale");
  }
  set locale(value) {
    this.__set("locale", value);
  }
  /**
   * @param date Date
   * @param referenceDate Date
   * @returns {string}
   */
  string(_date, _referenceDate) {
    throw new Error("Not implemented");
  }
  /**
   */
  useNamedDateTimeStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  useNumericDateTimeStyle() {
    throw new Error("Not implemented");
  }
}
class AbsReminder extends ScriptableObject {
  static __className = "Reminder";
  /**
   * _Identifier of reminder._
   */
  get identifier() {
    return this.__get("identifier");
  }
  set identifier(value) {
    this.__set("identifier", value);
  }
  /**
   * _Title of reminder._
   */
  get title() {
    return this.__get("title");
  }
  set title(value) {
    this.__set("title", value);
  }
  /**
   * _Notes associated with reminder._
   */
  get notes() {
    return this.__get("notes");
  }
  set notes(value) {
    this.__set("notes", value);
  }
  /**
   * _Whether the reminder is completed._
   */
  get isCompleted() {
    return this.__get("isCompleted");
  }
  set isCompleted(value) {
    this.__set("isCompleted", value);
  }
  /**
   * _Whether the reminder is overdue._
   */
  get isOverdue() {
    return this.__get("isOverdue");
  }
  set isOverdue(value) {
    this.__set("isOverdue", value);
  }
  /**
   * _Priority of reminder._
   *
   * Specifies the prirority of the reminder with 0 representing an undefined priority, 1 the highest priority, and 9 the lowest priority.
   */
  get priority() {
    return this.__get("priority");
  }
  set priority(value) {
    this.__set("priority", value);
  }
  /**
   * _Due date of reminder._
   *
   * @type {Date | null}
   */
  get dueDate() {
    return this.__get("dueDate");
  }
  set dueDate(value) {
    this.__set("dueDate", value);
  }
  /**
   * _Whether the due date includes a time._
   *
   * When this is true, assignments to the `dueDate` property will include a time, when this is false, the time component of the date will be ignored. Defaults to true.
   */
  get dueDateIncludesTime() {
    return this.__get("dueDateIncludesTime");
  }
  set dueDateIncludesTime(value) {
    this.__set("dueDateIncludesTime", value);
  }
  /**
   * _Completion date of reminder._
   *
   * @type {Date | null}
   */
  get completionDate() {
    return this.__get("completionDate");
  }
  set completionDate(value) {
    this.__set("completionDate", value);
  }
  /**
   * _Creation date of reminder._
   *
   * @type {Date | null}
   */
  get creationDate() {
    return this.__get("creationDate");
  }
  set creationDate(value) {
    this.__set("creationDate", value);
  }
  /**
   * _Calendar the reminder is stored in._
   */
  get calendar() {
    return this.__get("calendar");
  }
  set calendar(value) {
    this.__set("calendar", value);
  }
  /**
   * @param recurrenceRule RecurrenceRule
   */
  addRecurrenceRule(_recurrenceRule) {
    throw new Error("Not implemented");
  }
  /**
   */
  removeAllRecurrenceRules() {
    throw new Error("Not implemented");
  }
  /**
   */
  save() {
    throw new Error("Not implemented");
  }
  /**
   */
  remove() {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static scheduled(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static all(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static allCompleted(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static allIncomplete(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static allDueToday(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static completedDueToday(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static incompleteDueToday(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static allDueTomorrow(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static completedDueTomorrow(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static incompleteDueTomorrow(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static allDueYesterday(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static completedDueYesterday(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static incompleteDueYesterday(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static allDueThisWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static completedDueThisWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static incompleteDueThisWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static allDueNextWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static completedDueNextWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static incompleteDueNextWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static allDueLastWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static completedDueLastWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static incompleteDueLastWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static completedToday(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static completedThisWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static completedLastWeek(_calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param startDate Date
   * @param endDate Date
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static allDueBetween(_startDate, _endDate, _calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param startDate Date
   * @param endDate Date
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static completedDueBetween(_startDate, _endDate, _calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param startDate Date
   * @param endDate Date
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static incompleteDueBetween(_startDate, _endDate, _calendars) {
    throw new Error("Not implemented");
  }
  /**
   * @param startDate Date
   * @param endDate Date
   * @param calendars readonly Calendar[]
   * @returns {Promise<Reminder[]>}
   */
  static completedBetween(_startDate, _endDate, _calendars) {
    throw new Error("Not implemented");
  }
}
class AbsRequest extends ScriptableObject {
  static __className = "Request";
  /**
   * _URL to send request to._
   */
  get url() {
    return this.__get("url");
  }
  set url(value) {
    this.__set("url", value);
  }
  /**
   * _HTTP method used for the request._
   *
   * Specifies the HTTP method to use when sending the request. The default is to send the request using the GET HTTP method.
   */
  get method() {
    return this.__get("method");
  }
  set method(value) {
    this.__set("method", value);
  }
  /**
   * _HTTP headers to send with the request._
   *
   * Key value pairs where the key is the name of an HTTP header and the value will be sent as the value for the HTTP header.
   *
   * @type {{ [key: string]: string }}
   */
  get headers() {
    return this.__get("headers");
  }
  set headers(value) {
    this.__set("headers", value);
  }
  /**
   * _Body to send with the request._
   *
   * The body will be send along the request. While this property can be any value, currently only strings and Data is supported.
   *
   * Be aware that this property is ignored if you convert the request to a multipart request using `addParameterToMultipart`, `addFileToMultipart` or `addFileDataToMultipart`.
   */
  get body() {
    return this.__get("body");
  }
  set body(value) {
    this.__set("body", value);
  }
  /**
   * _Timeout interval of the request._
   *
   * If a request remains idle for longer than the timeout interval, the request is considered timed out.
   *
   * The timeout interval is measured in seconds and defaults to 60 seconds.
   */
  get timeoutInterval() {
    return this.__get("timeoutInterval");
  }
  set timeoutInterval(value) {
    this.__set("timeoutInterval", value);
  }
  /**
   * _Response of the request._
   *
   * The response is not populated until the request has been completed. The response is an object that looks like the following example.
   *
   * {
   * "url": "https://example.com/",
   * "statusCode": 200
   * "mimeType": "application/json",
   * "textEncodingName": "utf-8",
   * "headers": {
   * "Content-Type": "application/json;charset=utf-8",
   * "Content-Length": "17671"
   * },
   * "cookies": [{
   * "path": "/",
   * "httpOnly": true,
   * "domain": "www.example.com",
   * "sessionOnly": true,
   * "name": "JSESSIONID",
   * "value": "7616271F4878CFD05182D20C45F4CEB3"
   * }]
   * }
   *
   * @type {{ [key: string]: any }}
   */
  get response() {
    return this.__get("response");
  }
  set response(value) {
    this.__set("response", value);
  }
  /**
   * _Allow the request even if it is deemed insecure._
   *
   * By default Scriptable will attempt to reject requests that are deemed insecure.
   *
   * As an example, Scriptable will reject communicating with a server that has an invalid certificate. Such servers might be malicious and may put confidentional information at risk.
   * By enabling this setting, those requests will be allowed.
   *
   * Enable this setting at your own risk.
   */
  get allowInsecureRequest() {
    return this.__get("allowInsecureRequest");
  }
  set allowInsecureRequest(value) {
    this.__set("allowInsecureRequest", value);
  }
  /**
   * _Function called upon redirect._
   *
   * The function determines how redirects should be handled. By default redirects are allowed. When invoked the function is supplied with the request that we're about to redirect to.
   * The function can return the request to continue redirecting or it can return another request to redirect to. Returning null will stop the redirect. Note that onRedirect will only
   * be invoked on the initial request. Consecutive redirects should be handled on the initial request.
   *
   * @type {(arg0: Request) => Request}
   */
  get onRedirect() {
    return this.__get("onRedirect");
  }
  set onRedirect(value) {
    this.__set("onRedirect", value);
  }
  /**
   * @returns {Promise<Data>}
   */
  load() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<string>}
   */
  loadString() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<any>}
   */
  loadJSON() {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<Image>}
   */
  loadImage() {
    throw new Error("Not implemented");
  }
  /**
   * @param name string
   * @param value string
   */
  addParameterToMultipart(_name, _value) {
    throw new Error("Not implemented");
  }
  /**
   * @param data Data
   * @param mimeType string
   * @param name string
   * @param filename string
   */
  addFileDataToMultipart(_data, _mimeType, _name, _filename) {
    throw new Error("Not implemented");
  }
  /**
   * @param filePath string
   * @param name string
   * @param filename string
   */
  addFileToMultipart(_filePath, _name, _filename) {
    throw new Error("Not implemented");
  }
  /**
   * @param image Image
   * @param name string
   * @param filename string
   */
  addImageToMultipart(_image, _name, _filename) {
    throw new Error("Not implemented");
  }
}
class AbsSFSymbol extends ScriptableObject {
  static __className = "SFSymbol";
  /**
   * _Convert the symbol to an image._
   */
  get image() {
    return this.__get("image");
  }
  set image(value) {
    this.__set("image", value);
  }
  /**
   * @param font Font
   */
  applyFont(_font) {
    throw new Error("Not implemented");
  }
  /**
   */
  applyUltraLightWeight() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyThinWeight() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyLightWeight() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyRegularWeight() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyMediumWeight() {
    throw new Error("Not implemented");
  }
  /**
   */
  applySemiboldWeight() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyBoldWeight() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyHeavyWeight() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyBlackWeight() {
    throw new Error("Not implemented");
  }
  /**
   * @param symbolName string
   * @returns {SFSymbol}
   */
  static named(_symbolName) {
    throw new Error("Not implemented");
  }
}
class AbsSize extends ScriptableObject {
  static __className = "Size";
  /**
   * _Width value._
   */
  get width() {
    return this.__get("width");
  }
  set width(value) {
    this.__set("width", value);
  }
  /**
   * _Height value._
   */
  get height() {
    return this.__get("height");
  }
  set height(value) {
    this.__set("height", value);
  }
}
class AbsTextField extends ScriptableObject {
  static __className = "TextField";
  /**
   * _Text in the text field._
   */
  get text() {
    return this.__get("text");
  }
  set text(value) {
    this.__set("text", value);
  }
  /**
   * _Placeholder shown in the text field while it is empty._
   */
  get placeholder() {
    return this.__get("placeholder");
  }
  set placeholder(value) {
    this.__set("placeholder", value);
  }
  /**
   * _Hides the text that is entered when set to true._
   *
   * The default value is false.
   */
  get isSecure() {
    return this.__get("isSecure");
  }
  set isSecure(value) {
    this.__set("isSecure", value);
  }
  /**
   * _Color of the text._
   */
  get textColor() {
    return this.__get("textColor");
  }
  set textColor(value) {
    this.__set("textColor", value);
  }
  /**
   * _Font of the text._
   */
  get font() {
    return this.__get("font");
  }
  set font(value) {
    this.__set("font", value);
  }
  /**
   */
  setDefaultKeyboard() {
    throw new Error("Not implemented");
  }
  /**
   */
  setNumberPadKeyboard() {
    throw new Error("Not implemented");
  }
  /**
   */
  setDecimalPadKeyboard() {
    throw new Error("Not implemented");
  }
  /**
   */
  setNumbersAndPunctuationKeyboard() {
    throw new Error("Not implemented");
  }
  /**
   */
  setPhonePadKeyboard() {
    throw new Error("Not implemented");
  }
  /**
   */
  setWebSearchKeyboard() {
    throw new Error("Not implemented");
  }
  /**
   */
  setEmailAddressKeyboard() {
    throw new Error("Not implemented");
  }
  /**
   */
  setURLKeyboard() {
    throw new Error("Not implemented");
  }
  /**
   */
  setTwitterKeyboard() {
    throw new Error("Not implemented");
  }
  /**
   */
  leftAlignText() {
    throw new Error("Not implemented");
  }
  /**
   */
  centerAlignText() {
    throw new Error("Not implemented");
  }
  /**
   */
  rightAlignText() {
    throw new Error("Not implemented");
  }
}
class AbsTimer extends ScriptableObject {
  static __className = "Timer";
  /**
   * _The frequency at which the timer fires, in milliseconds._
   *
   * Be aware that the time interval is specified in setting. Defaults to 0, causing the timer to fire instantly.
   */
  get timeInterval() {
    return this.__get("timeInterval");
  }
  set timeInterval(value) {
    this.__set("timeInterval", value);
  }
  /**
   * _Whether the timer should repeat._
   *
   * A repeating timer will keep firing until it is invalidated. In contrast to non-repeating timers, repeating timers are not automatically invalidated. Defaults to false.
   */
  get repeats() {
    return this.__get("repeats");
  }
  set repeats(value) {
    this.__set("repeats", value);
  }
  /**
   * @param callback () => void
   */
  schedule(_callback) {
    throw new Error("Not implemented");
  }
  /**
   */
  invalidate() {
    throw new Error("Not implemented");
  }
  /**
   * @param timeInterval number
   * @param repeats boolean
   * @param callback () => void
   * @returns {Timer}
   */
  static schedule(_timeInterval, _repeats, _callback) {
    throw new Error("Not implemented");
  }
}
class AbsUITable extends ScriptableObject {
  static __className = "UITable";
  /**
   * _Whether to show separators._
   *
   * Whether to show separators between rows. Defaults to false.
   */
  get showSeparators() {
    return this.__get("showSeparators");
  }
  set showSeparators(value) {
    this.__set("showSeparators", value);
  }
  /**
   * @param row UITableRow
   */
  addRow(_row) {
    throw new Error("Not implemented");
  }
  /**
   * @param row UITableRow
   */
  removeRow(_row) {
    throw new Error("Not implemented");
  }
  /**
   */
  removeAllRows() {
    throw new Error("Not implemented");
  }
  /**
   */
  reload() {
    throw new Error("Not implemented");
  }
  /**
   * @param fullscreen boolean
   * @returns {Promise<void>}
   */
  present(_fullscreen) {
    throw new Error("Not implemented");
  }
}
class AbsUITableCell extends ScriptableObject {
  static __className = "UITableCell";
  /**
   * _Relative width of the cell._
   *
   * A width weight specifies the relative width of the cell. When computing the absolute width of the cell, all width weights are taken into account. Consider the following example.
   *
   * Cell A has a width weight of 50. Cell B has a width weight of 100. Cell C has a width wegiht of 150.
   *
   * Assume that the row has an absolute width of 100. The width will be distributed among cells A, B and C. B will be double as wide as A but C will be fifty percent wider than B and
   * three times as wide as A.
   */
  get widthWeight() {
    return this.__get("widthWeight");
  }
  set widthWeight(value) {
    this.__set("widthWeight", value);
  }
  /**
   * _Whether to dismiss the table when the button is tapped._
   *
   * Defaults to false.
   */
  get dismissOnTap() {
    return this.__get("dismissOnTap");
  }
  set dismissOnTap(value) {
    this.__set("dismissOnTap", value);
  }
  /**
   * _Color of the title._
   *
   * This only has an effect on cells with a title. By default the color is null, in which case an appropriate color is automatically chosen based on the theme of the app and the
   * context the script is running in.
   */
  get titleColor() {
    return this.__get("titleColor");
  }
  set titleColor(value) {
    this.__set("titleColor", value);
  }
  /**
   * _Color of the subtitle._
   *
   * This only has an effect on cells with a subtitle. By default the color is null, in which case an appropriate color is automatically chosen based on the theme of the app and the
   * context the script is running in.
   */
  get subtitleColor() {
    return this.__get("subtitleColor");
  }
  set subtitleColor(value) {
    this.__set("subtitleColor", value);
  }
  /**
   * _Font of the title._
   */
  get titleFont() {
    return this.__get("titleFont");
  }
  set titleFont(value) {
    this.__set("titleFont", value);
  }
  /**
   * _Font of the subtitle._
   */
  get subtitleFont() {
    return this.__get("subtitleFont");
  }
  set subtitleFont(value) {
    this.__set("subtitleFont", value);
  }
  /**
   * _Called when the button is tapped._
   *
   * Buttons cannot be tapped when the table is presented in Siri.
   *
   * @type {() => void}
   */
  get onTap() {
    return this.__get("onTap");
  }
  set onTap(value) {
    this.__set("onTap", value);
  }
  /**
   */
  leftAligned() {
    throw new Error("Not implemented");
  }
  /**
   */
  centerAligned() {
    throw new Error("Not implemented");
  }
  /**
   */
  rightAligned() {
    throw new Error("Not implemented");
  }
  /**
   * @param title string
   * @param subtitle string
   * @returns {UITableCell}
   */
  static text(_title, _subtitle) {
    throw new Error("Not implemented");
  }
  /**
   * @param image Image
   * @returns {UITableCell}
   */
  static image(_image) {
    throw new Error("Not implemented");
  }
  /**
   * @param url string
   * @returns {UITableCell}
   */
  static imageAtURL(_url) {
    throw new Error("Not implemented");
  }
  /**
   * @param title string
   * @returns {UITableCell}
   */
  static button(_title) {
    throw new Error("Not implemented");
  }
}
class AbsUITableRow extends ScriptableObject {
  static __className = "UITableRow";
  /**
   * _Spacing between cells._
   *
   * Specifies the horizontal spacing between cells in the row.
   */
  get cellSpacing() {
    return this.__get("cellSpacing");
  }
  set cellSpacing(value) {
    this.__set("cellSpacing", value);
  }
  /**
   * _Height of the row._
   *
   * The height of the row defaults to 44.
   */
  get height() {
    return this.__get("height");
  }
  set height(value) {
    this.__set("height", value);
  }
  /**
   * _Whether the cell is a header._
   *
   * Headers are highlighted cells that helps users understand context. Defaults to false.
   */
  get isHeader() {
    return this.__get("isHeader");
  }
  set isHeader(value) {
    this.__set("isHeader", value);
  }
  /**
   * _Whether to dismiss the table when the row is selected._
   *
   * This property will only have an effect if the row is selectable, i.e. `onSelect` has a value. Otherwise it is ignored.
   *
   * Defaults to true.
   */
  get dismissOnSelect() {
    return this.__get("dismissOnSelect");
  }
  set dismissOnSelect(value) {
    this.__set("dismissOnSelect", value);
  }
  /**
   * _Background color._
   */
  get backgroundColor() {
    return this.__get("backgroundColor");
  }
  set backgroundColor(value) {
    this.__set("backgroundColor", value);
  }
  /**
   * _Called when the row is selected._
   *
   * Called when the row is selected when the table is presented. If this has no value, the row cannot be selected. Defaults to null.
   *
   * Rows cannot be tapped when the tables is presented in Siri.
   *
   * @type {() => void}
   */
  get onSelect() {
    return this.__get("onSelect");
  }
  set onSelect(value) {
    this.__set("onSelect", value);
  }
  /**
   * @param cell UITableCell
   */
  addCell(_cell) {
    throw new Error("Not implemented");
  }
  /**
   * @param title string
   * @param subtitle string
   * @returns {UITableCell}
   */
  addText(_title, _subtitle) {
    throw new Error("Not implemented");
  }
  /**
   * @param image Image
   * @returns {UITableCell}
   */
  addImage(_image) {
    throw new Error("Not implemented");
  }
  /**
   * @param url string
   * @returns {UITableCell}
   */
  addImageAtURL(_url) {
    throw new Error("Not implemented");
  }
  /**
   * @param title string
   * @returns {UITableCell}
   */
  addButton(_title) {
    throw new Error("Not implemented");
  }
}
class AbsWebView extends ScriptableObject {
  static __className = "WebView";
  /**
   * _Function called upon load of a request._
   *
   * When the web view performs a request to load a resource, the function can determine whether or not to allow the request. Disallowing request can speed up the time it takes to load
   * the website. Requests made from JavaScript in the page are not passed to this function.
   *
   * By default all requests are allowed.
   *
   * @type {(arg0: Request) => boolean}
   */
  get shouldAllowRequest() {
    return this.__get("shouldAllowRequest");
  }
  set shouldAllowRequest(value) {
    this.__set("shouldAllowRequest", value);
  }
  /**
   * @param url string
   * @returns {Promise<void>}
   */
  loadURL(_url) {
    throw new Error("Not implemented");
  }
  /**
   * @param request Request
   * @returns {Promise<void>}
   */
  loadRequest(_request) {
    throw new Error("Not implemented");
  }
  /**
   * @param html string
   * @param baseURL string
   * @returns {Promise<void>}
   */
  loadHTML(_html, _baseURL) {
    throw new Error("Not implemented");
  }
  /**
   * @param fileURL string
   * @returns {Promise<void>}
   */
  loadFile(_fileURL) {
    throw new Error("Not implemented");
  }
  /**
   * @param javaScript string
   * @param useCallback boolean
   * @returns {Promise<any>}
   */
  evaluateJavaScript(_javaScript, _useCallback) {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<any>}
   */
  getHTML() {
    throw new Error("Not implemented");
  }
  /**
   * @param fullscreen boolean
   * @returns {Promise<void>}
   */
  present(_fullscreen) {
    throw new Error("Not implemented");
  }
  /**
   * @returns {Promise<any>}
   */
  waitForLoad() {
    throw new Error("Not implemented");
  }
  /**
   * @param html string
   * @param baseURL string
   * @param preferredSize Size
   * @param fullscreen boolean
   * @returns {Promise<void>}
   */
  static loadHTML(_html, _baseURL, _preferredSize, _fullscreen) {
    throw new Error("Not implemented");
  }
  /**
   * @param fileURL string
   * @param preferredSize Size
   * @param fullscreen boolean
   * @returns {Promise<void>}
   */
  static loadFile(_fileURL, _preferredSize, _fullscreen) {
    throw new Error("Not implemented");
  }
  /**
   * @param url string
   * @param preferredSize Size
   * @param fullscreen boolean
   * @returns {Promise<void>}
   */
  static loadURL(_url, _preferredSize, _fullscreen) {
    throw new Error("Not implemented");
  }
}
class AbsWidgetDate extends ScriptableObject {
  static __className = "WidgetDate";
  /**
   * _Date to show in a widget._
   */
  get date() {
    return this.__get("date");
  }
  set date(value) {
    this.__set("date", value);
  }
  /**
   * _Color of the text._
   */
  get textColor() {
    return this.__get("textColor");
  }
  set textColor(value) {
    this.__set("textColor", value);
  }
  /**
   * _Font and text size of the text._
   */
  get font() {
    return this.__get("font");
  }
  set font(value) {
    this.__set("font", value);
  }
  /**
   * _Opacity of the text._
   *
   * Opacity of the text. This must be a value between 0 and 1. Defaults to 1.
   */
  get textOpacity() {
    return this.__get("textOpacity");
  }
  set textOpacity(value) {
    this.__set("textOpacity", value);
  }
  /**
   * _Maximum number of lines._
   *
   * Maximum number of lines to display. The limit is disabled when the value is 0 or less. Defaults to 0.
   */
  get lineLimit() {
    return this.__get("lineLimit");
  }
  set lineLimit(value) {
    this.__set("lineLimit", value);
  }
  /**
   * _Minimum amount the text scales down to._
   *
   * Sets the minimum amount that text scales down to fit in the available space. For example, a text with a minimum scale factor of 0.5 allows the widget to draw the text in a font
   * size half the size of the actual font. The scale factor should be a fraction between 0 and 1, both inclusive. Defaults to 1.
   */
  get minimumScaleFactor() {
    return this.__get("minimumScaleFactor");
  }
  set minimumScaleFactor(value) {
    this.__set("minimumScaleFactor", value);
  }
  /**
   * _Color of the shadow._
   *
   * Sets the color of the shadow cast by the text. The `shadowRadius` property must have a value greater than zero for this property to have an effect. Defaults to black.
   */
  get shadowColor() {
    return this.__get("shadowColor");
  }
  set shadowColor(value) {
    this.__set("shadowColor", value);
  }
  /**
   * _Size of the shadow._
   *
   * Sets the size of the shadow cast by the text. Defaults to 0.
   */
  get shadowRadius() {
    return this.__get("shadowRadius");
  }
  set shadowRadius(value) {
    this.__set("shadowRadius", value);
  }
  /**
   * _Offset of the shadow._
   *
   * Sets the offset of the shadow cast by the text. The `shadowRadius` property must have a value greater than zero for this property to have an effect. Defaults to (0, 0).
   */
  get shadowOffset() {
    return this.__get("shadowOffset");
  }
  set shadowOffset(value) {
    this.__set("shadowOffset", value);
  }
  /**
   * _URL to open._
   *
   * The URL will be opened when the text is tapped. This is only supported in medium and large widgets. Small widgets can only have a single tap target, which is specified by the `url`
   * property in the widget configurator.
   */
  get url() {
    return this.__get("url");
  }
  set url(value) {
    this.__set("url", value);
  }
  /**
   */
  leftAlignText() {
    throw new Error("Not implemented");
  }
  /**
   */
  centerAlignText() {
    throw new Error("Not implemented");
  }
  /**
   */
  rightAlignText() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyTimeStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyDateStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyRelativeStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyOffsetStyle() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyTimerStyle() {
    throw new Error("Not implemented");
  }
}
class AbsWidgetImage extends ScriptableObject {
  static __className = "WidgetImage";
  /**
   * _Image to show in widget._
   */
  get image() {
    return this.__get("image");
  }
  set image(value) {
    this.__set("image", value);
  }
  /**
   * _Whether the image is resizable._
   *
   * When set to true, the image can be resized. Defaults to true.
   */
  get resizable() {
    return this.__get("resizable");
  }
  set resizable(value) {
    this.__set("resizable", value);
  }
  /**
   * _Size of the image in the widget._
   *
   * Size of the image. When set to null, the image will be shwon at its full size. Defaults to null.
   */
  get imageSize() {
    return this.__get("imageSize");
  }
  set imageSize(value) {
    this.__set("imageSize", value);
  }
  /**
   * _Opacity when shown in widget._
   *
   * Opacity of the image. This must be a value between 0 and 1. Defaults to 1.
   */
  get imageOpacity() {
    return this.__get("imageOpacity");
  }
  set imageOpacity(value) {
    this.__set("imageOpacity", value);
  }
  /**
   * _Radius of the corners._
   *
   * Radius of the rounded corners. This property is ignored when `containerRelativeShape` is set to true. Defaults to 0.
   */
  get cornerRadius() {
    return this.__get("cornerRadius");
  }
  set cornerRadius(value) {
    this.__set("cornerRadius", value);
  }
  /**
   * _Border width._
   *
   * Width of the border around the image. Defaults to 0.
   */
  get borderWidth() {
    return this.__get("borderWidth");
  }
  set borderWidth(value) {
    this.__set("borderWidth", value);
  }
  /**
   * _Border color._
   *
   * Color of the border around the image. Defaults to black.
   */
  get borderColor() {
    return this.__get("borderColor");
  }
  set borderColor(value) {
    this.__set("borderColor", value);
  }
  /**
   * _Shape the image relative to its container._
   *
   * When true the corners of the image will be rounded relative to the containing widget. The value of `cornerRadius` is ignored when this is true. Defaults to false.
   */
  get containerRelativeShape() {
    return this.__get("containerRelativeShape");
  }
  set containerRelativeShape(value) {
    this.__set("containerRelativeShape", value);
  }
  /**
   * _Tint color of the image._
   *
   * Changes the color of the image. Set to `null` to show the original image. Defaults to `null`.
   */
  get tintColor() {
    return this.__get("tintColor");
  }
  set tintColor(value) {
    this.__set("tintColor", value);
  }
  /**
   * _URL to open._
   *
   * The URL will be opened when the image is tapped. This is only supported in medium and large widgets. Small widgets can only have a single tap target, which is specified by the `url`
   * on the widget.
   */
  get url() {
    return this.__get("url");
  }
  set url(value) {
    this.__set("url", value);
  }
  /**
   */
  leftAlignImage() {
    throw new Error("Not implemented");
  }
  /**
   */
  centerAlignImage() {
    throw new Error("Not implemented");
  }
  /**
   */
  rightAlignImage() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyFittingContentMode() {
    throw new Error("Not implemented");
  }
  /**
   */
  applyFillingContentMode() {
    throw new Error("Not implemented");
  }
}
class AbsWidgetSpacer extends ScriptableObject {
  static __className = "WidgetSpacer";
  /**
   * _Amount of space this spacer consumes._
   */
  get length() {
    return this.__get("length");
  }
  set length(value) {
    this.__set("length", value);
  }
}
class AbsWidgetStack extends ScriptableObject {
  static __className = "WidgetStack";
  /**
   * _Background color of the stack._
   */
  get backgroundColor() {
    return this.__get("backgroundColor");
  }
  set backgroundColor(value) {
    this.__set("backgroundColor", value);
  }
  /**
   * _Background image._
   */
  get backgroundImage() {
    return this.__get("backgroundImage");
  }
  set backgroundImage(value) {
    this.__set("backgroundImage", value);
  }
  /**
   * _Background gradient._
   */
  get backgroundGradient() {
    return this.__get("backgroundGradient");
  }
  set backgroundGradient(value) {
    this.__set("backgroundGradient", value);
  }
  /**
   * _Spacing between elements._
   *
   * Specifies the spacing between elements in the stack. You can also use the `addSpacer()` function on the widget to add spacing between elements. Defaults to 0.
   */
  get spacing() {
    return this.__get("spacing");
  }
  set spacing(value) {
    this.__set("spacing", value);
  }
  /**
   * _Size of the stack._
   *
   * Specifies the size of the stack when shown in a widget. When a dimension is set to zero or less, the widget will automatically decide a length for that dimension. Both dimensions
   * default to 0.
   */
  get size() {
    return this.__get("size");
  }
  set size(value) {
    this.__set("size", value);
  }
  /**
   * _Radius of the corners._
   *
   * Radius of the rounded corners. Defaults to 0.
   */
  get cornerRadius() {
    return this.__get("cornerRadius");
  }
  set cornerRadius(value) {
    this.__set("cornerRadius", value);
  }
  /**
   * _Border width._
   *
   * Width of the border around the stack. Defaults to 0.
   */
  get borderWidth() {
    return this.__get("borderWidth");
  }
  set borderWidth(value) {
    this.__set("borderWidth", value);
  }
  /**
   * _Border color._
   *
   * Color of the border around the stack. Defaults to black.
   */
  get borderColor() {
    return this.__get("borderColor");
  }
  set borderColor(value) {
    this.__set("borderColor", value);
  }
  /**
   * _URL to open._
   *
   * The URL will be opened when the stack is tapped. This is only supported in medium and large widgets. Small widgets can only have a single tap target, which is specified by the `url`
   * property in the widget configurator.
   */
  get url() {
    return this.__get("url");
  }
  set url(value) {
    this.__set("url", value);
  }
  /**
   * @param text string
   * @returns {WidgetText}
   */
  addText(_text) {
    throw new Error("Not implemented");
  }
  /**
   * @param date Date
   * @returns {WidgetDate}
   */
  addDate(_date) {
    throw new Error("Not implemented");
  }
  /**
   * @param image Image
   * @returns {WidgetImage}
   */
  addImage(_image) {
    throw new Error("Not implemented");
  }
  /**
   * @param length number
   * @returns {WidgetSpacer}
   */
  addSpacer(_length) {
    throw new Error("Not implemented");
  }
  /**
   * @returns {WidgetStack}
   */
  addStack() {
    throw new Error("Not implemented");
  }
  /**
   * @param top number
   * @param leading number
   * @param bottom number
   * @param trailing number
   */
  setPadding(_top, _leading, _bottom, _trailing) {
    throw new Error("Not implemented");
  }
  /**
   */
  useDefaultPadding() {
    throw new Error("Not implemented");
  }
  /**
   */
  topAlignContent() {
    throw new Error("Not implemented");
  }
  /**
   */
  centerAlignContent() {
    throw new Error("Not implemented");
  }
  /**
   */
  bottomAlignContent() {
    throw new Error("Not implemented");
  }
  /**
   */
  layoutHorizontally() {
    throw new Error("Not implemented");
  }
  /**
   */
  layoutVertically() {
    throw new Error("Not implemented");
  }
}
class AbsWidgetText extends ScriptableObject {
  static __className = "WidgetText";
  /**
   * _Text to show in a widget._
   */
  get text() {
    return this.__get("text");
  }
  set text(value) {
    this.__set("text", value);
  }
  /**
   * _Color of the text._
   */
  get textColor() {
    return this.__get("textColor");
  }
  set textColor(value) {
    this.__set("textColor", value);
  }
  /**
   * _Font and text size of the text._
   */
  get font() {
    return this.__get("font");
  }
  set font(value) {
    this.__set("font", value);
  }
  /**
   * _Opacity of the text._
   *
   * Opacity of the text. This must be a value between 0 and 1. Defaults to 1.
   */
  get textOpacity() {
    return this.__get("textOpacity");
  }
  set textOpacity(value) {
    this.__set("textOpacity", value);
  }
  /**
   * _Maximum number of lines._
   *
   * Maximum number of lines to display. The limit is disabled when the value is 0 or less. Defaults to 0.
   */
  get lineLimit() {
    return this.__get("lineLimit");
  }
  set lineLimit(value) {
    this.__set("lineLimit", value);
  }
  /**
   * _Minimum amount the text scales down to._
   *
   * Sets the minimum amount that text scales down to fit in the available space. For example, a text with a minimum scale factor of 0.5 allows the widget to draw the text in a font
   * size half the size of the actual font. The scale factor should be a fraction between 0 and 1, both inclusive. Defaults to 1.
   */
  get minimumScaleFactor() {
    return this.__get("minimumScaleFactor");
  }
  set minimumScaleFactor(value) {
    this.__set("minimumScaleFactor", value);
  }
  /**
   * _Color of the shadow._
   *
   * Sets the color of the shadow cast by the text. The `shadowRadius` property must have a value greater than zero for this property to have an effect. Defaults to black.
   */
  get shadowColor() {
    return this.__get("shadowColor");
  }
  set shadowColor(value) {
    this.__set("shadowColor", value);
  }
  /**
   * _Size of the shadow._
   *
   * Sets the size of the shadow cast by the text. Defaults to 0.
   */
  get shadowRadius() {
    return this.__get("shadowRadius");
  }
  set shadowRadius(value) {
    this.__set("shadowRadius", value);
  }
  /**
   * _Offset of the shadow._
   *
   * Sets the offset of the shadow cast by the text. The `shadowRadius` property must have a value greater than zero for this property to have an effect. Defaults to (0, 0).
   */
  get shadowOffset() {
    return this.__get("shadowOffset");
  }
  set shadowOffset(value) {
    this.__set("shadowOffset", value);
  }
  /**
   * _URL to open._
   *
   * The URL will be opened when the text is tapped. This is only supported in medium and large widgets. Small widgets can only have a single tap target, which is specified by the `url`
   * property in the widget configurator.
   */
  get url() {
    return this.__get("url");
  }
  set url(value) {
    this.__set("url", value);
  }
  /**
   */
  leftAlignText() {
    throw new Error("Not implemented");
  }
  /**
   */
  centerAlignText() {
    throw new Error("Not implemented");
  }
  /**
   */
  rightAlignText() {
    throw new Error("Not implemented");
  }
}
class AbsXMLParser extends ScriptableObject {
  static __className = "XMLParser";
  /**
   * _XML string to be parsed._
   */
  get string() {
    return this.__get("string");
  }
  set string(value) {
    this.__set("string", value);
  }
  /**
   * _Function called when the parser begins parsing a document._
   *
   * @type {() => void}
   */
  get didStartDocument() {
    return this.__get("didStartDocument");
  }
  set didStartDocument(value) {
    this.__set("didStartDocument", value);
  }
  /**
   * _Function called when the parser ends parsing a document._
   *
   * When the parser calls the function, it has successfully completed parsing the document.
   *
   * @type {() => void}
   */
  get didEndDocument() {
    return this.__get("didEndDocument");
  }
  set didEndDocument(value) {
    this.__set("didEndDocument", value);
  }
  /**
   * _Function called when starting to parse an element._
   *
   * Called by the parser when it encounters a start tag for an element. The function takes the element name as a parameter as well as a key value pair containing all the attributes
   * associated with the element.
   *
   * Use this function to update your state and prepare for receiving the characters of the element. After this function is called, the parser will call the foundCharacters callback
   * function with all or parts of the characters of the element.
   *
   * @type {(arg0: string, arg1: { [key: string]: string }) => void}
   */
  get didStartElement() {
    return this.__get("didStartElement");
  }
  set didStartElement(value) {
    this.__set("didStartElement", value);
  }
  /**
   * _Function called when ended parsing an element._
   *
   * Called by the parser when it encounters an end tag for an element. The function takes the element name as a parameter.
   *
   * @type {(name: string) => void}
   */
  get didEndElement() {
    return this.__get("didEndElement");
  }
  set didEndElement(value) {
    this.__set("didEndElement", value);
  }
  /**
   * _Function called when the parser finds characters of an element._
   *
   * The parser calls this function with a string whenever it finds characters for the current element. This function may be called several times for a single element.
   *
   * @type {(str: string) => void}
   */
  get foundCharacters() {
    return this.__get("foundCharacters");
  }
  set foundCharacters(value) {
    this.__set("foundCharacters", value);
  }
  /**
   * _Function called when the parser encounters an error._
   *
   * The parser will call this function when it encounters a fatal error preventing it from continuing to parse. When the function is called the parsing is stopped.
   *
   * @type {(error: string) => void}
   */
  get parseErrorOccurred() {
    return this.__get("parseErrorOccurred");
  }
  set parseErrorOccurred(value) {
    this.__set("parseErrorOccurred", value);
  }
  /**
   * @returns {boolean}
   */
  parse() {
    throw new Error("Not implemented");
  }
}

exports.AbsAlert = AbsAlert;
exports.AbsCalendar = AbsCalendar;
exports.AbsCalendarEvent = AbsCalendarEvent;
exports.AbsCallbackURL = AbsCallbackURL;
exports.AbsColor = AbsColor;
exports.AbsContact = AbsContact;
exports.AbsContactsContainer = AbsContactsContainer;
exports.AbsContactsGroup = AbsContactsGroup;
exports.AbsData = AbsData;
exports.AbsDateFormatter = AbsDateFormatter;
exports.AbsDatePicker = AbsDatePicker;
exports.AbsDrawContext = AbsDrawContext;
exports.AbsFileManager = AbsFileManager;
exports.AbsFont = AbsFont;
exports.AbsImage = AbsImage;
exports.AbsLinearGradient = AbsLinearGradient;
exports.AbsListWidget = AbsListWidget;
exports.AbsMail = AbsMail;
exports.AbsMessage = AbsMessage;
exports.AbsNotification = AbsNotification;
exports.AbsPath = AbsPath;
exports.AbsPoint = AbsPoint;
exports.AbsRect = AbsRect;
exports.AbsRecurrenceRule = AbsRecurrenceRule;
exports.AbsRelativeDateTimeFormatter = AbsRelativeDateTimeFormatter;
exports.AbsReminder = AbsReminder;
exports.AbsRequest = AbsRequest;
exports.AbsSFSymbol = AbsSFSymbol;
exports.AbsSize = AbsSize;
exports.AbsTextField = AbsTextField;
exports.AbsTimer = AbsTimer;
exports.AbsUITable = AbsUITable;
exports.AbsUITableCell = AbsUITableCell;
exports.AbsUITableRow = AbsUITableRow;
exports.AbsWebView = AbsWebView;
exports.AbsWidgetDate = AbsWidgetDate;
exports.AbsWidgetImage = AbsWidgetImage;
exports.AbsWidgetSpacer = AbsWidgetSpacer;
exports.AbsWidgetStack = AbsWidgetStack;
exports.AbsWidgetText = AbsWidgetText;
exports.AbsXMLParser = AbsXMLParser;
exports.ScriptableObject = ScriptableObject;
//# sourceMappingURL=index.js.map
//# sourceMappingURL=index.js.map